/* main.c - main subroutine that calls TSEC apis */

/*  Copyright 2005-2006 Freescale Semiconductor */
/*
modification history
--------------------
01a,19jul05,ahk written
*/

/*
DESCRIPTION

INCLUDE Files: MPC8560.h, tsec.h
*/

/* includes */

#include <stdio.h>
#include <string.h>
#include "MPC8560.h"
#include "tsec.h"


/* defines */



/* typedefs */


/* globals */

mpc_imm                 *pCCSRBAR; /* pointer to the ccsrbar */
mpq_tsec				*pTsecMap; /* pointer to tsec memory mapped registers */


/* forward declaration */

extern void epicInit   ( void );


/******************************************************************
* main - calls other subroutines and intializes tsec and phy
*
* This routine calls other subroutines to initialize the mac
* controller of TSEC. If user selects TSEC PHY digital loopback then
* it also initializes the PHY. This routine calls subroutine to 
* setup the management interface.
*
* RETURNS: None
*      
* ERRNO: None 
*
*/

void main()
{
	printf("\n\r");
	printf("\n\r");	
	printf("===========================================\n\r");
	printf("TSEC init code...\n\r");

	pCCSRBAR = (mpc_imm *)CCSRBAR_ADDR;                /* codewarrior config file maps the */
	                                                   /* CCSRBAR to 0x4000_000 */
	pTsecMap = (mpq_tsec *)&pCCSRBAR->tsec[TSEC_ID_1]; /* points to mem map reg of TSEC1 */
	epicInit();
	tsecInit();
	while(1);
}


